/* ***** BEGIN LICENSE BLOCK *****
 * Version: MPL 1.1/GPL 2.0/LGPL 2.1
 *
 * The contents of this file are subject to the Mozilla Public License Version
 * 1.1 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * The Original Code is AddressbooksSynchronizer.
 *
 * The Initial Developer of the Original Code is Gnter Gersdorf.
 * Portions created by the Initial Developer are Copyright (C) 2006
 * the Initial Developer. All Rights Reserved.
 *
 * Contributor(s):
 *  Gnter Gersdorf <G.Gersdorf@ggbs.de>
 *
 * Alternatively, the contents of this file may be used under the terms of
 * either the GNU General Public License Version 2 or later (the "GPL"), or
 * the GNU Lesser General Public License Version 2.1 or later (the "LGPL"),
 * in which case the provisions of the GPL or the LGPL are applicable instead
 * of those above. If you wish to allow use of your version of this file only
 * under the terms of either the GPL or the LGPL, and not to allow others to
 * use your version of this file under the terms of the MPL, indicate your
 * decision by deleting the provisions above and replace them with the notice
 * and other provisions required by the GPL or the LGPL. If you do not delete
 * the provisions above, a recipient may use your version of this file under
 * the terms of any one of the MPL, the GPL or the LGPL.
 *
 * ***** END LICENSE BLOCK ***** */

var gState=STATE_UPLOADING;

var usespopup;
var gLifeTime=2;//in seconds.
var abData=null;
var abURI=null;
var abMime='text/plain';
var ioService=Components.classes["@mozilla.org/network/io-service;1"]
               .getService(Components.interfaces.nsIIOService);
var mabFiles;
var strings;
var syncing;

var cleanUp=null;
var gAbort=0;

var gTempName;

function upload()
{
  usespopup=window.location=='chrome://addressbookssync/content/upload.xul';

  strings = document.getElementById("strings");

  var synctype='none';
  var doc=usespopup?window.opener.document:document;
  // no doc if called from thunderbird exit
  if (doc && doc.getElementById( "UseMabFile" ) && doc.getElementById( "UseMabFile" ).value) {
    mabFiles=new Array(doc.getElementById( "UseMabFile" ).value);
    doc.getElementById( "UseMabFile" ).value='';
    synctype='remote';
    syncing=false;
  } else {
    mabFiles=syncedAddressbooks();
    try{ synctype = pref.getCharPref( "extensions.addressbookssync.synctype" ); }
      catch(e){ synctype = 'none'; }
    syncing=true;
  }

  if (synctype=='local') {
    setTimeout(sendLocalData, 0);   // give popup time to show up
  } else if (synctype=='remote') {
    abURI=getSyncURI(false);
    setTimeout(sendData, 0);
  } else if (synctype=='imap') {
    setTimeout(imapSave, 0);
  } else {
    killMe();
  }

}

function sendLocalData() {
  var localpath=pref.getCharPref( "extensions.addressbookssync.localpath" )
  if (localpath) {
    var dir = Components.classes["@mozilla.org/file/local;1"].createInstance(Components.interfaces.nsILocalFile);
    dir.initWithPath( localpath );
    for (var i = 0; i < mabFiles.length; i++) {
      if (gAbort) break;
      var mabFile=mabFiles[i];
      var cur=getAddressBook(mabFile);
      var mabName=cur.directoryProperties.description;
      var uri = cur.directoryProperties.URI;

      var localFileName;
      if (!syncing || uri!=kPersonalAddressbookURI && uri!=kCollectedAddressbookURI)
        localFileName = mabName+'.mab'; //ex: =mabFile
      else
        localFileName = '_tb_'+cur.directoryProperties.fileName;

      statustxt(mabName+'..', true, false);
      if (saveMabFile(mabName, mabFile, dir, localFileName))
        statustxt(strings.getString('copied'), false, false);
      else
        statustxt(strings.getString('notcopied'), false, true);
    }
  }
  killMe();
}

function sendData()
{
    if (!checkOffline()) return;
    var mabFile=mabFiles.pop();
    if (!mabFile || gAbort) {
      killMe();
      return;
    }
    var cur=getAddressBook(mabFile);
    var mabName=cur.directoryProperties.description;
    var uri = cur.directoryProperties.URI;

    var remoteFileName;
    if (!syncing || uri!=kPersonalAddressbookURI && uri!=kCollectedAddressbookURI)
      remoteFileName = mabName+".mab";
    else
      remoteFileName = '_tb_'+cur.directoryProperties.fileName;

    statustxt("upload "+mabName+".", true, false);  // 1. dot: start

    var mabURI=abURI+remoteFileName;
    var URI=ioService.newURI(mabURI,null,null);

    nsIMabFile=getDir('ProfD');
    nsIMabFile.appendRelativePath( mabFile );
    abData=readMabData(nsIMabFile);
    if (!abData) {
      uploadCallback("done",-2); // file does not exist
      return;
    }
    statustxt(".", false, false); // 2. dot: file loaded

    if( ! gBookmarksSynchronizerUploadService.start(abData, URI, abMime, uploadCallback))
      uploadCallback("done",-1);
    else
      statustxt(".", false, false); // 4. dot: upload start is finished
}

function uploadCallback(aStatus,aError)
{
  if (aStatus=='send') {  //caled from within gBookmarksSynchronizerUploadService.start
    statustxt('.', false, false); // 3. dot: upload started
    return;
  } else {  // upload finished (called with aStatus='done' from gBookmarksSynchronizerUploadService)
    var error=errorstr(aError);
    if (error!=strings.getString('ok')) {
      statustxt(error, false, true);
      gLifeTime=5;//in seconds.
      killMe();
      return;
    }
    statustxt(error, false, false);
  }
  if (usespopup) sendData(); //next addressbook
  else setTimeout(sendData, 1000);
}

function cancelUpload()
{
  if (gAbort) {
    gAbort++;
    killMe();
  } else {
    gAbort++;
    document.getElementById("abs_cancel").label='kill';
  }
  // gBookmarksSynchronizerUploadService.cancel();  // no or we may left behind corrupted files
}

